import java.awt.*;
import java.awt.geom.Point2D;

public class Bullet extends Projectile
{
	private int damage;
	
	public Bullet (DPoint spawn, double direction, int damage)
	{
		super(spawn, 1, direction + Math.random() * 30 - 15);
		
		this.damage = damage;
	}
	
	public void cycle (int time)
	{
		if (! move(0.7 * time))
		{
			GameArea.getLevel().removeEntity(this);
		}
	}
	
	public boolean collision (Entity e)
	{
		if (e instanceof Damageable)
		{
			Damageable entity = (Damageable) e;
			
			entity.damage(damage);
			
			GameArea.getLevel().removeEntity(this);
			
			return true;
		}
		else
		{
			return super.collision(e);
		}
	}
	
	public void draw (Graphics g, Layer layer, int xOffset, int yOffset)
	{
		if (layer != this.layer)
		{
			return;
		}
		
		int relativeX = x() - 1 - xOffset;
		int relativeY = y() - 1 - yOffset;
		
		g.setColor(Color.BLACK);
		g.fillRect(relativeX, relativeY, 2, 2);
	}
}
