import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

class DButton extends JButton
{
	DButton (String text, String command, int size)
	{
		this(text, command, Main.getInstance(), size);
	}
	
	DButton (String text, String command, ActionListener target, int size)
	{
		super(text);
		
		setFont(getFont().deriveFont((float) size));
		
		setAlignmentX(Component.CENTER_ALIGNMENT);
		
		setActionCommand(command);
		
		addActionListener(target);
	}
	
	public void paintComponent (Graphics g)
	{
		Graphics2D g2 = (Graphics2D) g;
		
		g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
		
		super.paintComponent(g);
	}
}
