import java.awt.geom.Point2D;

class DPoint extends Point2D.Double
{
	DPoint (double x, double y)
	{
		super(x, y);
	}
	
	DPoint (Point2D point)
	{
		this(point.getX(), point.getY());
	}
	
	DPoint (Point2D point, double forwards, double sideways, double direction)
	{
		this(point);
		
		translate(forwards, sideways, direction);
	}
	
	public int x ()
	{
		return (int) x;
	}
	
	public int y ()
	{
		return (int) y;
	}
	
	public DPoint getLocation ()
	{
		return new DPoint(this);
	}
	
	public void translate (double forwards, double sideways, double direction)
	{
		double radians = Direction.toRadians(direction);
		
		double cos = Math.cos(radians);
		double sin = Math.sin(radians);
		
		double dx = cos * forwards - sin * sideways;
		double dy = sin * forwards + cos * sideways;
		
		x += dx;
		y += dy;
	}
	
	public double direction (Point2D there)
	{
		double xDist = there.getX() - x;
		double yDist = there.getY() - y;
		
		return Direction.fromRadians(Math.atan2(yDist, xDist));
	}
	
	public static double distance (Point2D a, Point2D b)
	{
		return a.distance(b);
	}
}
