

public class DTimer
{
	private long startTime;
	private long base = 0;
	private boolean running = false;

	public void start ()
	{
		if (! running)
		{
			running = true;
			startTime = now();
		}
	}

	public void stop ()
	{
		if (running)
		{
			running = false;
			base += now() - startTime;
		}
	}

	public long getTime ()
	{
		if (running)
		{
			return (base + now()) - startTime;
		}
		else
		{
			return base;
		}
	}
	
	public long timeSince (long time)
	{
		return (getTime() - time);
	}

	public String toString ()
	{
		return toString(getTime());
	}
	
	private long now ()
	{
		return System.nanoTime() / 1000000;
	}

	public static String toString (long time)
	{
		long inSeconds = time / 1000;
		
		int seconds = (int) (inSeconds % 60);
		
		long inMinutes = inSeconds / 60;
		
		int minutes = (int) (inMinutes % 60);
		
		long inHours = inMinutes / 60;
		
		String ret = String.valueOf(seconds);
		
		if (seconds < 10)
		{
			ret = "0" + ret;
		}
		
		ret = minutes + ":" + ret;
		
		if (minutes < 10)
		{
			ret = "0" + ret;
		}
		
		if (inHours > 0)
		{
			ret = inHours + ":" + ret;
		}
		
		return ret;
	}
}
