import java.awt.*;

class DeadBody extends RotatingEntity
{
	protected long died;
	
	DeadBody (Human human)
	{
		super(human.getLocation(), Layer.BELOW_PEOPLE, 16, human.getDirection());
		
		Sprite sprite = Store.newSprite(human.type + "-death", true, 150);
		
		sprite.setLimit(1);
		
		setSprite(sprite);
		
		died = GameArea.timer.getTime();
	}
	
	public void cycle (int time)
	{
		if ((sprite != null) && ! sprite.isRunning())
		{
			Image[] frames = getSprite().getFrames();
			
			Image levelImage = GameArea.getLevel().getImage();
			
			Graphics g = levelImage.getGraphics();
			
			drawRotatedImage(g, frames[frames.length-1], direction.toRadians(), x(), y());
			
			setSprite(null);
		}
	}
}
