

class Direction
{
	private double direction;
	
	public static final double FULL = 1200;
	public static final double HALF = 600;
	public static final double QUARTER = 300;
	
	public static final double NORTH = -300;
	public static final double EAST = 0;
	public static final double SOUTH = 300;
	public static final double WEST = 600;
	
	Direction ()
	{
		setRandom();
	}
	
	Direction (double d)
	{
		direction = d;
	}
	
	Direction (Direction d)
	{
		direction = d.getValue();
	}
	
	public double getValue ()
	{
		return direction;
	}
	
	public void setValue (double d)
	{
		direction = d;
	}
	
	public void setRandom ()
	{
		direction = Math.random() * FULL;
	}
	
	public void turnLeft (double d)
	{
		direction -= d;
	}
	
	public void turnRight (double d)
	{
		direction += d;
	}
	
	public double relative (double d)
	{
		return relative(direction, d);
	}
	
	public double toRadians ()
	{
		return toRadians(direction);
	}
	
	public static double relative (double d1, double d2)
	{
		double diff = d1 - d2;
		
		while (diff > HALF)
		{
			diff -= FULL;
		}
		
		while (diff < -HALF)
		{
			diff += FULL;
		}
		
		return diff;
	}
	
	public static double toRadians (double d)
	{
		return (d * Math.PI) / HALF;
	}
	
	public static double fromRadians (double d)
	{
		return (d * HALF) / Math.PI;
	}
}
