

class Guard extends ArmedHuman
{
	private long nextShoot = 0;
	
	private DPoint lastSeen = null;
	private boolean hasSeenWithGun = false;
	
	Guard (DPoint p)
	{
		super(p, "guard", 30);
		
		setWeapons(new Weapon[] {
			new Unarmed(this),
			new Pistol(this),
		});
		
		setCarrying(new String[] {"PistolAmmo"});
	}
	
	public void cycle (int time)
	{
		Player player = Player.getInstance();
		
		boolean canSee = canSee(player);
		
		if (! hasSeenWithGun && canSee && ! (player.getWeapon() instanceof Unarmed))
		{
			hasSeenWithGun = true;
			setWeapon(1);
		}
		
		if (hasSeenWithGun)
		{
			if (canSee)
			{
				lastSeen = new DPoint(player);
				
				DPoint gunpoint = new DPoint(this, 15, 10, direction.getValue());
				
				double playerDirection = gunpoint.direction(player);
				
				double diff = turnTowards(playerDirection, 2 * time);
				
				if (-75 < diff && diff < 75)
				{
					double dist = distance(player);
					
					boolean shoot = true;
					
					if (dist > 200)
					{
						shoot = ! move(RUN, time);
					}
					else
					{
						if (dist > 100)
						{
							move(WALK, time);
						}
						else if (dist < 50)
						{
							move(BACK, time);
						}
						else
						{
							move(STILL, time);
						}
					}
					
					long now = GameArea.timer.getTime();
					
					if (nextShoot == 0)
					{
						nextShoot = now + 1000 + (long) (1000 * Math.random());
					}
					else if (now > nextShoot)
					{
						weapon.fire();
						
						nextShoot = now + 1000 + (long) (1000 * Math.random());
					}
				}
			}
			else
			{
				nextShoot = 0;
				
				if (lastSeen == null)
				{
					wander(time);
				}
				else
				{
					if (distance(lastSeen) < 3)
					{
						lastSeen = null;
					}
					else
					{
						moveTowards(lastSeen, WALK, 1, time);
					}
				}
			}
		}
		else
		{
			/*for (Entity entity: GameArea.getLevel().entities)
			{
				if (canSee(entity))
				{
					if (entity instanceof DeadBody)
					{
						moveTowards(entity, RUN, 2);
						return;
					}
					else if (entity instanceof Explosion)
					{
						
					}
				}
			}*/
			
			wander(time);
		}
	}
}
