import java.awt.*;
import java.awt.event.*;

public class KeyTypedHandler implements KeyEventDispatcher
{
	private final KeyboardFocusManager manager;
	
	private final KeyTypedListener listener;
	
	public KeyTypedHandler (KeyTypedListener listener)
	{
		manager = KeyboardFocusManager.getCurrentKeyboardFocusManager();
		
		this.listener = listener;
	}
	
	public void start ()
	{
		manager.addKeyEventDispatcher(this);
	}
	
	public void stop ()
	{
		manager.removeKeyEventDispatcher(this);
	}
	
	public boolean dispatchKeyEvent (KeyEvent e)
	{
		if (e.getID() == KeyEvent.KEY_TYPED)
		{
			char c = e.getKeyChar();
			
			listener.keyTyped(c);
		}
		
		return false;
	}
}
