import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
// import org.draknek.widgets.*;

public class Main extends JApplet implements WindowFocusListener, ActionListener
{
	public static int WIDTH = 640;
	public static int HEIGHT = 480;
	public static String TITLE = "Operation Meltdown";
	
	private static Main instance;
	
	private static Component currentScreen;
	
	public static Main getInstance ()
	{
		return instance;
	}
	
	public Main ()
	{
		instance = this;
		
		setLayout(new BorderLayout());
	}
	
	public void init ()
	{
		try
		{
			Store.load();
		}
		catch (Exception e)
		{
			System.err.println("Failed to load files");
			
			e.printStackTrace();
			
			System.exit(1);
		}
		
		setScreen(new MainScreen());
	}
	
	public void start ()
	{
		if (currentScreen instanceof InteractiveComponent)
		{
			((InteractiveComponent)currentScreen).start();
		}
	}
	
	public void stop ()
	{
		if (currentScreen instanceof InteractiveComponent)
		{
			((InteractiveComponent)currentScreen).stop();
		}
	}
	
	public static void setScreen (Component c)
	{
		if (currentScreen != null)
		{
			if (currentScreen instanceof InteractiveComponent)
			{
				((InteractiveComponent)currentScreen).end();
			}
			
			instance.remove(currentScreen);
		}
		
		instance.add(c);
		
		instance.validate();
		
		if (c instanceof InteractiveComponent)
		{
			((InteractiveComponent)c).init();
		}
		
		currentScreen = c;
	}
	
	public void windowGainedFocus (WindowEvent e)
	{
		 start();
	}
	
	public void windowLostFocus (WindowEvent e)
	{
		 stop();
	}
	
	public void actionPerformed (ActionEvent e)
	{
		String command = e.getActionCommand();
		
		if (command.equals("mainmenu"))
		{
			setScreen(new MainScreen());
		}
		else if (command.equals("start"))
		{
			setScreen(new IntroScreen1());
		}
		else if (command.equals("controls"))
		{
			setScreen(new ControlsScreen());
		}
	}
	
	public static void main (String[] args)
	{
		Main content = new Main();
		
		JFrame window = new JFrame(TITLE);
		
		window.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		window.addWindowFocusListener(content);
		window.setLocationByPlatform(true);
		window.setPreferredSize(new Dimension(WIDTH, HEIGHT));
		window.setResizable(false);
		window.setContentPane(content);
		
		window.pack();
		
		content.init();
		
		window.setVisible(true);
	}
}
