

class Mechanic extends Human
{
	private Sprite walkSprite;
	private Sprite fixSprite;
	
	Mechanic (DPoint spawn)
	{
		super(spawn, "engineer", 25);
		
		walkSprite = Store.newSprite("engineer", false);
		fixSprite = Store.newSprite("engineer-fix", true, 500);
	}
	
	public void cycle (int time)
	{
		setSprite(walkSprite);
		
		Player player = Player.getInstance();
		
		if (canSee(player) && ! (player.getWeapon() instanceof Unarmed))
		{
			moveTowards(player, BACK, 1, time);
			return;
		}
		
		for (Entity entity: GameArea.getLevel().entities)
		{
			if (entity instanceof Regulator && canSee(entity))
			{
				Regulator regulator = (Regulator) entity;
				
				if (regulator.isDamaged())
				{
					DPoint ahead = new DPoint(this, 3, 0, direction.getValue());
					
					if (wouldTouch(ahead, regulator))
					{
						regulator.heal(0.004 * time);
						
						setSprite(fixSprite);
					}
					else
					{
						moveTowards(regulator, WALK, 1, time);
					}
					
					return;
				}
			}
		}
		
		// If we got here, there are no damaged regulators in sight
		
		wander(time);
	}
}
