import java.awt.*;

abstract class Pickup extends Entity
{
	private Image pickup;
	protected CircularCollisionArea collision;
	
	Pickup (DPoint start, String type)
	{
		super(start, Layer.BELOW_PEOPLE);
		
		setSprite(Store.newSprite("spin"));
		
		pickup = Store.getImage("pickup-" + type);
		
		collision = new CircularCollisionArea(this, 10);
	}
	
	public CollisionArea getCollisionArea ()
	{
		return collision;
	}
	
	public void cycle (int time)
	{
		Player player = Player.getInstance();
		
		if (touching(player))
		{
			if (player.pickup(this))
			{
				GameArea.getLevel().removeEntity(this);
			}
		}
	}
	
	public void draw (Graphics g, Layer layer, int xOffset, int yOffset)
	{
		if (layer != this.layer)
		{
			return;
		}
		
		drawCentredImage(g, pickup, x() - xOffset, y() - yOffset);
		
		super.draw(g, layer, xOffset, yOffset);
	}
}
