import java.awt.*;
import java.awt.geom.Point2D;

public class Rocket extends Projectile
{
	private double speed = 0.1;
	
	public Rocket (DPoint spawn, double direction)
	{
		super(spawn, 4, direction);
		
		Sprite sprite = new Sprite(Store.getImage("rocket"));
		
		setSprite(sprite);
	}
	
	public void cycle (int time)
	{
		if (! move(speed * time))
		{
			explode();
		}
		
		if (speed < 1)
		{
			speed += 0.01 * time;
		}
	}
	
	public void explode ()
	{
		Store.stopAudio("rocket-fire");
		
		GameArea.getLevel().removeEntity(this);
			
		GameArea.getLevel().addEntity(new Explosion(this));
	}
}
