import java.awt.*;

class Stairs extends Entity
{
	private String level;
	
	private double moveX;
	private double moveY;
	
	private boolean drawn = false;
	
	protected RectangularCollisionArea collision;
	
	Stairs (DPoint p, String level, int newX, int newY, String updown)
	{
		super(p, Layer.BELOW_PEOPLE);
		
		Sprite sprite = new Sprite(Store.getImage("stairs-" + updown));
		
		setSprite(sprite);
		
		this.level = level;
		
		moveX = newX - getX();
		moveY = newY - getY();
		
		collision = new RectangularCollisionArea(this, -16, (updown.equals("up") ? -16 : 11), 32, 5);
	}
	
	public CollisionArea getCollisionArea ()
	{
		return collision;
	}
	
	public void cycle (int time)
	{
		Player player = Player.getInstance();
		
		if (touching(player))
		{
			GameArea.load(level, player.x + moveX, player.y + moveY);
		}
	}
	
	public void draw (Graphics g, Layer layer, int xOffset, int yOffset)
	{
		if (drawn || layer != this.layer)
		{
			return;
		}
		
		Graphics levelGraphics = GameArea.getLevel().getImage().getGraphics();
		
		drawCentredImage(levelGraphics, sprite.getImage(), x(), y());
		
		drawn = true;
		
		super.draw(g, layer, xOffset, yOffset);
	}
}
